#include "VideoEnde.h"
#include <Bild.h>
#include <MausEreignis.h>
#include <Rahmen.h>
#include <Schrift.h>
#include <Text.h>

// Inhalt der VideoEnde Klasse aus VideoEnde.h
// Konstruktor
VideoEnde::VideoEnde( UIInit &uiFactory )
    : ReferenceCounter()
{
    text = uiFactory.createTextFeld( uiFactory.initParam );
    text->setStyle( TextFeld::Style::Text | TextFeld::Style::Center | TextFeld::Style::Rahmen | TextFeld::Style::Hintergrund | TextFeld::Style::HAlpha );
    text->removeStyle( TextFeld::Style::Sichtbar );
    text->setText( "" );
    text->setSize( 220, 70 );
    text->setRahmenBreite( 2 );
    text->setRahmenFarbe( 0xFFFFFFFF );
    text->setHintergrundFarbe( 0xA0000000 );
}

// Destruktor
VideoEnde::~VideoEnde()
{
    text->release();
}

// nicht constant
void VideoEnde::setSichtbar( bool b )
{
    text->setStyle( TextFeld::Style::Sichtbar, b );
}

void VideoEnde::setText( const char *txt )
{
    text->zTextRenderer()->setSchriftSize( 12 );
    Text t = txt;
    text->setSize( 10 + text->zTextRenderer()->getTextBreite( t ), 10 + text->zTextRenderer()->getTextHeight( t ) );
    text->setText( txt );
}

void VideoEnde::render( Bild &zRObj )
{
    text->setPosition( zRObj.getBreite() / 2 - text->getBreite() / 2, zRObj.getHeight() / 2 - text->getHeight() / 2 );
    text->render( zRObj );
}

// constant
bool VideoEnde::istSichtbar() const
{
    return text->hatStyle( TextFeld::Style::Sichtbar );
}