#ifndef VideoSteuerung_H
#define VideoSteuerung_H

#include <Knopf.h>
#include <UIInitialization.h>

using namespace Framework;

class VideoSteuerung : public virtual ReferenceCounter
{
private:
    Punkt pos;
    Knopf *verlassen;
    Knopf *langsamer;
    Knopf *stop;
    Knopf *schneller;
    TextFeld *zeit;
    double spielZeit;
    int speed;
    bool vorwrts;
    bool zeitlupe;
    bool beendet;
    bool bJetzt;

public:
    // Konstruktor
    VideoSteuerung( UIInit &uiFactory );
    // Destruktor
    ~VideoSteuerung();
    // Nicht constant
    void doPublicMausEreignis( MausEreignis &me );
    bool tick( double zeit );
    void render( Bild &zRObj );
    void pause( bool ende );
    bool istBeendet( bool jetzt );
    // constant
    int getSpeed() const;
    bool istVorwrts() const;
    bool istZeitlupe() const;
};

#endif