#ifndef StatistikRunde_H
#define StatistikRunde_H

#include <Bild.h>
#include <TextFeld.h>
#include <UIInitialization.h>
#include "../SpielStatistikDaten.h"

using namespace Framework;

class StatistikRunde : public virtual ReferenceCounter
{
private:
    BildZ *rundenBild;
    TextFeld *rundenNummer;
    TextFeld *rundenDauer;
    TextFeld *rundenSieger;
    TextFeld *spielfeldNutzung;
    TextFeld *verbleibend;
    Array< SSDRunde * > *daten;
    int auswahl;
    double verb;
    bool rend;

public:
    // Konstruktor
    StatistikRunde( UIInit &uiFactory, Array< SSDRunde * > *dat, bool historie = 0 );
    // Destruktor
    ~StatistikRunde();
    // nicht constant
    void setRunde( int nummer );
    void doPublicMausEreignis( MausEreignis &me );
    bool tick( double tickVal );
    void render( Bild &zRObj );
    // constant
    bool mussVerlassen() const;
};

#endif