#ifndef StatistikTabelle_H
#define StatistikTabelle_H

#include <Tabelle.h>
#include <AuswahlBox.h>
#include <UIInitialization.h>
#include "../SpielStatistikDaten.h"

using namespace Framework;

class StatistikTabelle : public virtual ReferenceCounter
{
private:
    UIInit uiFactory;
    Array< SSDGesamtSpieler * > *ssdgs;
    Array< SSDGesamtTeam * > *ssdgt;
    Array< SSDRunde * > *ssdr;
    AuswahlBox *stAuswahl;
    AuswahlBox *grAuswahl;
    AuswahlBox *sortAuswahlGS;
    AuswahlBox *sortAuswahlGT;
    RCArray< AuswahlBox > *sortAuswahlRS;
    RCArray< AuswahlBox > *sortAuswahlRT;
    AuswahlBox *sortRichtungGS;
    AuswahlBox *sortRichtungGT;
    RCArray< AuswahlBox > *sortRichtungRS;
    RCArray< AuswahlBox > *sortRichtungRT;
    ObjTabelle *gesamtSpieler;
    ObjTabelle *gesamtTeam;
    RCArray< ObjTabelle > *rundeSpieler;
    RCArray< ObjTabelle > *rundeTeam;
    bool teamS;
    int rundeAusw;
    bool rend;
    // privat
    void tabelleLehren( ObjTabelle *zT, bool berschrift );
    void tabelleFllen( ObjTabelle *zT );

public:
    // Konstruktor
    StatistikTabelle( Array< SSDGesamtSpieler * > *ssdgs, Array< SSDGesamtTeam * > *ssdgt, Array< SSDRunde * > *ssdr, UIInit &uiFactory, bool historie = 0 );
    // Destruktor
    ~StatistikTabelle();
    // nicht constant
    void doPublicMausEreignis( MausEreignis &me );
    bool tick( double tickVal );
    void render( Bild &zRObj );
    // constant
    int getRunde() const;
};

#endif